Version 0.16.0.1 released 30 Aug 2026

  * Support for pandoc 3.11.

Version 0.16 released 10 Jun 2026

  * Remove unnecessary templatesPath field in GititState (Profpatsch)
    [API change]. The templates are directly pulled out of the config
    and then never changed, so no reason to put the field in state.

  * Add Paths_gitit to autogen-modules in executable section.

  * Change Git repository location to HTTPS (Felix Yan).
    `git://` is no longer supported.

  * Remove RPXnow authentication (Profpatsch).

  * Move everything from xhtml to blaze & HTML5 (Profpatsch).

  * Fix Redirect `<meta>` header (Profpatsch).

  * Remove old MathMLinHTML.hs. Browsers support MathML now.

  * Remove deprecated projection media type in template.

  * Remove old comment workaround needed for IE6 in template.

  * Raise upper bound for zlib, network, aeson, http-client, hoauth2,
    pandoc, xml-conduit.

  * Require filestore >= 0.6.5.1 (#710).

  * Correct a typo in src/Network/Gitit/ContentTransformer.hs (Felix Yan).

  * Fix link & mention of highlighting-kate in README (#711).

Version 0.15.1.2 released 27 Jan 2024

  * Allow happstack-server 7.9.

  * Test on ghc 9.6, remove testing for 8.8.

  * Remove dependency on the unmaintained Config package (#696).
    Instead, we implement a simple config file parser in
    parsec. The format of the config file is identical, and there should
    not be major differences in the behavior of the parser.

  * Allow building with Stackage LTS-22 (sternenseemann).

  * .cabal: move doc files to extra-doc-files (Jens Petersen).
    Only README.markdown is needed at runtime, so move CHANGES
    and extra license files to extra-doc-files

Version 0.15.1.1 released 03 Jul 2023

  * Allow latest aeson.

  * Allow building with Stackage lts-21 (sternenseemann).

  * Allow building with lts-20 (#685, Jens Petersen).

  * Adjust for hoauth2 >= 2.3.0 (sternenseemann).


Version 0.15.1.0 released 10 Dec 2021

  * Set the portable flag on sendfile to avoid an error
    on Windows builds (#651).

  * Fix Windows stack build (mintty issue).

  * Update dependencies to use latest released pandoc.

  * Update CI and add a Windows build.

  * Use `mkSessionCookie` to fix a regression introduced in
    0.15.0.0 which made user sessions unreadable, breaking
    user authentication (#674).

  * Network.Gitit.Framework: export `mkSessionCookie` [API change].

  * Fix build for pandoc <= 2.12.0 (#676, Stephen Paul Weber).


Version 0.15.0.0 released 12 Aug 2021

  * Remove the Export feature entirely.
    There were too many security problems associated with exports.
    Given limitations on developer time, removing the feature entirely
    seemed the best solution.  API change: removed Network.Gitit.Export.

  * Fix dependencies to compile with ghc 9.

Version 0.14.0.0 released 12 Aug 2021

  * PDF export: fix vulnerability.  Augustin Laville pointed
    out that it is possible to leak content from files on the
    file system in PDF export.  This can be done by simply including

        \include{/path/to/file}

    in the markdown; the raw tex is passed through to the
    LaTeX intermediary when producing a PDF.  In many cases
    this will lead to a LaTeX syntax error, but there are ways of
    injecting TeX includes into a verbatim environment.
    The solution is to cause latex to use a local texmf.cnf
    file when exporting PDF. The texmf.cnf file can specify
    openout_any = p and openin_any = p, which prevents access
    to hidden files and files outside the current tree.

  * Made SessionKey a newtype (API change).  This avoids orphan
    instance warnings.  Removed unused orphan `instance FromReqURI [String]`.

  * Remove deprecated `defaultCleanupHandler`.

  * Handle Underline element in converting inlines to strings.

  * Allow compilation with pandoc 2.12 and 2.13 (#670, sterni).
    pandoc 2.13 introduced the following breakages for gitit.

  * Allow building with pandoc-2.14 (#673, Jens Petersen).

  * Disable registration bug fixes (#669, zaxtax).
    Display correct html, fix precedence bug.

  * Add documentation and comment on disabling registration to
    default config (Rob Zinkov).

  * Add option for disabling registration (Rob Zinkov).

  * Depend on filestore >= 0.6.5 (with embedded data).

  * Relax version bounds in gitit.cabal to fix build from hackage
    (#665, sternenseemann).

  * Allow building with hoauth-1.14 (Jens Petersen).

Version 0.13.0.0 released 03 June 2020

  * Allow building with GHC 8.8

    + Network.Gitit.Rpxnow: change return type of `authenticate` to
      avoid using removed instances of `Monad.fail`

  * Upgrade dependencies and add nix section to stack.yaml
    (Fabián Heredia Montiel).

  * Fixes to compile with feed-1.3.x (octalsrc).
    The changes to EntryContent in feed-1.2.0.0 were reverted
    in 1.3.0.0

  * Fixes to compile with network-3.x (octalsrc).
    network-3.0.0.0 moves the Network.BSD module into its own
    "network-bsd" package and removes deprecated API elements.  This
    requires a new dependency on "network-bsd" and a code change to stop
    using the removed inet_addr function.
    This change also adds < 3.2 as an upper bound for network (there was
    previously no upper bound).

  * Fixes to compile with hoauth2-1.11.x (octalsrc).
    This also fixes type mismatches that prevent compiling with
    hoauth-1.9.x

  * Fixes to compile with GHC 8.8.x, API change in Network.Gitit.Rpxnow
    (octalsrc).  GHC 8.8's base-4.13.0.0 removes `fail` from Monad,
    requiring a few uses of `fail` to be removed and the json dependency
    to be updated.  Because arbitrary `Monad` instances no longer
    support failure, the `Monad m` used in the return type of
    Network.Gitit.Rpxnow.authenticate has been fixed as `Either String`.

  * Allow pandoc 2.9.x.

  * Diff fixes in Feed.

  * Modernize cabal file (require cabal 2.0).

  * Changes to use filestore 0.6.4.

Version 0.12.3.2 released 31 Dec 2018

  * Remove references to gitit.net in cabal file.
    gitit.net is no longer owned by the project and
    has not served a demo of gitit for some time (#627).

Version 0.12.3.1 released 31 Dec 2018

  * Improve compatibility with GHC 8.6 (Phil Ruffwind, #625).

    + Replaced uses of uri (out of date package) with uri-bytestring, which
      gitit already uses in other places.
    + Bumped hoauth2 version bounds to support 1.8.*.

Version 0.12.3 released 09 Oct 2018

  * Change hk-pyg.css to highlighting.css with new CSS for pandoc 2
    and skylighting 0.7.4. NOTE:  You must change your existing
    custom.css to refer to highlighting.css instead of
    hk-pyg.css, or highlighted code will not display properly.
  * Ensure that the proper extensions are used for each format.
  * Add Ext_emoji to readerExtensions (#616).
  * Add Paths_gitit to other-modules to avoid warning.
  * screen.css: remove special padding and border and color for code.
    This interferes with pandoc's new highlighting.
  * Fixed static in gitignore
  * Update stack.yaml, use latest lts-12.
  * Updates for pandoc 2.x (Myron Wu).
  * Require skylighting >= 0.7.4.
  * Remove jsMath as it was dropped from pandoc >= 2 (#617, Myron Wu).
  * Add Ext_emoji to readerExtensions (#616, Conal Elliott).
  * Changes to use recent versions of dependencies.
    Especially feed 1.0, which uses a different xml type
    and requires a new dependency on xml-conduit to render it.
  * Remove support for ghc versions < 8 (Myron Wu).
  * Bump hoauth2 to 1.3.0 && < 1.6 to catch up with nix and other
    curated package sets (Myron Wu).
  * Updated mathjax cdn to cloudflare.
  * Redirect to requested wiki page after github oauth callback (Myron Wu).
  * Use skylighting instead of deprecated highlighting-kate.

Version 0.12.2.1 released 14 Feb 2017

  * Bump version bounds for time, pandoc, blaze-html, aeson.
  * Added MTable plugin (Simon Heath).
    Adds simple but easy-to-use variable-width table syntax.
  * Fixed Subst plugin (Simon Heath, #548).
  * Fixed Dot plugin (Simon Heath, #568).

Version 0.12.2 released 09 Nov 2016

  * Allow pandoc 1.18, tagsoup 0.14, aeson, 1.x.

Version 0.12.1.1 released 22 Mar 2016

  * Allow pandoc 1.17 (Phil Ruffwind).
  * Allow aeson 0.11.

Version 0.12.1 released 17 Feb 2016

  * Use fmap instead of <$> so ghc 7.8 won't fail.
  * Allow latest hoauth2
  * Fix typo (Chas Leichner).
  * Allow compiling with pandoc 1.16.x.
  * Add page for login failure when authorization is required for reading
    (Phil Ruffwind).  When authorization is required to read the wiki, the
    error message from a failed GitHub login cannot be displayed.  Instead it
    will redirect to GitHub for another OAuth authentication, which can lead to
    a redirect loop.  To avoid this, the user is now redirected to a special
    landing page to display the login failure.  Note: no changes are made for
    the case where authorization is not required to read the wiki.
  * Improve error message of GitHub membership check (Phil Ruffwind).
  * Add delete-summary config variable (Phil Ruffwind).
    Used to change the commit message when a page is deleted.
  * Use primary GitHub email rather than just the first (Phil Ruffwind).
    The order in which user emails are returned via the GitHub API is not
    specified, so the first may not be the one that the user prefers,
    i.e. the so-called "primary" email.  To fix this problem, we eliminate
    all emails except for the one marked as "primary".
  * Make default theme responsive (Lincoln Mullen, #450).
    This commit makes the default theme responsive. For smaller browsers, it
    will move the sidebar below the main content div and make the sidebar
    three columns. On phones, it will also collapse the sidebar into a
    single column.
  * README: Tell how to enable rtsopts for disabling GC (norpol).

Version 0.12.0.1 released 24 Aug 2015

  * Revert change of curly to straight quote for starting
    User's Guide page (Wouter Oosterveld).
  * stack.yaml: removed pandoc flag setting.

Version 0.12 released 19 Aug 2015

  * Export all modules.
  * Make executable builds depend on the library in cabal file.
  * Moved library files to src directory.
  * Added stack.yaml.
  * Updated README with stack install instructions.

Version 0.11.1.1 released 14 Aug 2015

  * Fixed Network.Gitit.Initialize so it compiles with older pandoc (#506).
  * Removed extra import of liftIO in Dot.hs plugin.

Version 0.11.1 released 23 Jul 2015

  * Allow `commonmark` as a page type.
  * Handle CommonMark page type on initialization.

Version 0.11 released 02 Jun 2015

  * Allow page extensions to be configurable (not just `.page`)
    (Caleb McDaniel).
    - Added `page-extension` option in config file (Caleb McDaniel).
    - Added new type for `defaultExtension`
    - Changed `isPageFile` to get extension from config
    - New function `isNotDiscussPageFile`
    - `pathForPage` must be passed extension as String
    - `isPageFile` now returns GititServerPart Bool instead of just Bool.
  * Reverted some changes to Plugins that caused excessive memory use.
  * Allow pandoc 1.15.
  * Added missing `<br>` tag in form on registration page (Vaughn Iverson).
  * Show page diffs in feed (Imuli).
  * Display commit messages in feed entry titles (Imuli).
  * Fix preview button for modern jQuery (Imuli).
  * Feed titles reflect site and page names (Imuli).
  * Present feed in canonical order (recent first, Imuli).
  * https support for base-url config option (Imuli).

Version 0.10.7 released 02 Jun 2015

  * Fixes to allow building with pandoc 1.14. `CommonMark` added
    as a constructor of `PageType`.  CommonMark can now be used as
    a page format and is also available for page export.
  * Plugins:  added some recommended option flags.
  * Allow `---` as well as `...` to end metadata (#493).
  * README: changed dead links (Rick Hanson).

Version 0.10.6.3 released 08 May 2015

  * README:  use shortcut style markdown links.
  * Fixed profiling options.
  * Added .travis.yml.
  * Allow both time >= 1.5.0.0 and time < 1.5.0.0 with old-locale
    (Michal Antkiewicz)

Version 0.10.6.2 released 02 April 2015

  * Bumped upper version bounds.
  * Fix typos in README.markdown (Igor Vuk).
  * Update bug tracker link (Waldir Pimenta).

Version 0.10.6.1 released 28 October 2014

  * Added Network.Gitit.Compat.Except to cabal module list.

Version 0.10.6 released 28 October 2014

  * Escape HTML characters in user name when showing it on a web page.
    This addresses a security flaw in previous versions, pointed out
    by Davy Stoffel.  A fake password reset email could be provided
    to users, with the link:

        http://gitit.net/_doResetPassword?reset_code=azeaze&username=
        davy%3Cscript%3Ealert%281%29%3C/script%3E

    If the person clicked the link, the unknown username would be
    displayed (unescaped), and the javascript would run.
    This fix addresses the flaw, not by preventing the funny user name,
    but by ensuring that the HTML tags are escaped when the user name
    is shown on the page.

  * Network.Gitit.Initialize: Allow mediawiki for default pages.

  * Enable readerParseRaw for all formats.
    This will enable things like script and iframe tags to get
    parsed from HTML sources, and unrecognized latex tags from LaTeX.

  * Refined github login (Freiric Barral).

  * Include jquery sources in sdist tarballs (Anthony Towns).

  * Add support for `mediawiki` as a page format (Raymond Gauthier).

Version 0.10.5.1 released 21 September 2014

  * Added markup help for org mode.  Closes #449.

  * Utils.parsePageType:  Added case for "org".

  * Allow newer versions of dependencies.

Version 0.10.5 released 23 August 2014

  * Added github login option (Freiric Barral).

  * Change default math display to mathjax.

  * Relaxed package bounds, fixed compiler warnings.
    Added Network.Gitit.Compat.Except module for compatibility
    with earlier and later mtl versions.

  * Added network-uri flag to accommodate network-uri/network split.

  * Fixed failure when loading the Subst plugin (Glenn Searby).

  * Added Makefile, for use in installing on server.

  * Include takeBaseName in System.FilePath import (Caleb McDaniel).

  * Update README.markdown on Apache installation (Peter Gallagher).

  * Add full versions of minified JavaScript (#400) (Peter Gallagher).

  * Enable highlighting of patterns that start or end with punctuation
    (Caleb McDaniel).

  * Moved oauth secret to separate config file (Freiric Barral).

  * Corrected MathJax CDN URL (Maciek Makowski).

Version 0.10.4 released 30 Jun 2014

*   Updated package bounds for happstack (#382), pandoc, blaze-html,
    network.

*   Display EPS as image, not code.

*   Fixed recent activity page for binary files (Sergey Koposov).

*   Use normal spaces instead of nbsp in activity page (Sergey Koposov).

*   Display a delete link next to uploads in file list (rekado).

*   Change _search to use HTTP GET, so searches can be linked
    and refreshed (Joe Hillenbrand).

*   Document mod_proxy_html setting in README.  Added a mod_proxy_html
    configuration directive to insert a DOCTYPE string (Johann Visagie).

*   Added new template variables `isdiscusspage`, `isarticleUrl`,
    `discussionUrl`.  This makes it possible to treat discussion pages
    specially in templates, and insert appropriate links (Shane O'Brien).

*   Added template variables `articlename`, `discussionname`,
    `isarticlepage` (Shane O'Brien).

*   Added redirects (#233).  You can now create a redirect page by adding
    a `redirect` field to the metadata of a page (Shane O'Brien).

    - When a user visits a redirect page, they are redirected to the
      destination page.
    - At the destination page, a message is displayed telling the user
      that they have been redirected from the source page. A link is
      provided back to the source page, with a parameter to disable the
      redirect (so that it can be edited).
    - Gitit will detects circular redirects and explain to the user
      what is going on in such cases.

*   Added "search for pages containing..." option to `createPage`.
    Changed "page not found" page to give the option of searching for
    the page name or creating a page with that name (Shane O'Brien).

*   Set `pgTitle` in `showDiff` (Shane O'Brien).

*   Made the default "since" for the activity page configurable
    (Shane O'Brien).

*   Only set the `tabs` template variable if there are tabs (Shane O'Brien).

*   Removed access question from password reset form. It's only
    needed for the register form (Shane O'Brien).

*   Added `for` attribute to all labels on forms (Shane O'Brien).

*   Updated `pageToString` to use new metadata format (Shane O'Brien).

*   Handlers: Fixed duplicate function defn for `fileAnchor`.

*   Added `Org` and `BocBook` to `PageType` (API change).  Pages
    may now be written in Ord mode or DocBook syntax.

*   Allow multiple categories, separated by commas,
    in a `_category` URL (Caleb McDaniel).  The pages in all listed
    categories will be returned.

*   Added filter links for `_category` pages (Cabel McDaniel).

*   Fixed image exports in Docx, RTF, slides, PDF (#399, #353).

*   Restored inline syntax highlighting.

*   Fixed highlighting in exports (#356).

*   Added `ICML` and `beamer` as export formats (#391).

*   Added github-style backgrounds to code blocks (Joe Hillenbrand).

*   Lighter heading border (like wikimedia) (Joe Hillenbrand).

*   Fixed links on activity page (Shane O'Brien).

*   Added markup help for Textile, Org, DocBook (#434).

*   Modified plugins/Subst.hs to work with latest pandoc (Tianyi Cui).

*   Fixed wiki links when `base-url` is empty and `absolute-urls` yes
    (Tianyi Cui).

*   README:  document that changes to templates require a restart (Raphael).


Version 0.10.3.1 released 19 Mar 2013

*   Fixed filename encoding problem affecting caching,
    for gitit compiled with GHC 7.4 or later.

*   Fixed padding on some buttons (akerbos).

*   Specify correct format in header for initial pages (benmachine).

Version 0.10.3 released 09 Mar 2013

*   Allow latest versions of pandoc, blaze-html, HStringTemplate.

*   Fixed duplicate ids in user box.

*   Added `mathjax-script` option, specifies the mathjax script to
    use. (Dmitry Gerasimov.)

*   Set focus on editedText on page load.  (Mathieu Larose.)

*   Added `address` config option.  (Matieu Larose.)

Version 0.10.2 released 09 Feb 2013

*   Updated to work with pandoc 1.10.

*   Fixed path for MathMLInHTML.js script.  Closes #345.
    Thanks to tstgruby.

*   Updated interwiki plugin (gwern).

*   Made it possible to export pages with images stored in the
    repository itself (as opposed to the static directory).  Thanks
    to Claudio Bley for the patch.

Version 0.10.1.2 released 11 Jan 2013

*   Fixed regression in option parsing.  An earlier patch
    caused the '-f' option not to work.  Closes #336.

Version 0.10.1.1 released 01 Jan 2013

*   Allow compilation with directory < 1.2.

Version 0.10.1 released 31 Dec 2012

*   Fixed duplicate dropExtension on categoryPage.  (atsuo yamada)
    This created problems with categories containing periods.

*   Fixed duplicate unescaping of HTML entities. (atsuo yamada)

*   Supply $revision$ at _diff if "Changes from beginning to..."
    (atsuo yamada)

*   MathJax rendering is now working in edit preview mode
    (Dmitry Gerasimov).

*   Upgrade directory package dependency to 1.2, and
    fix compilation issue with GHC 7.6.1 (Bin Jin).

*   Allow metadata keys to include digits, _, -.  Closes #328.

*   Don't read config for --help or --version (Ben Millwood).
    Also involves a refactor of options into those that make the program
    quit immediately, and those that just alter the configuration.

*   Updated to use filestore 0.6 (new diff API).
    Thanks to markwright for partial patch.

*   Include format metadata in default installed pages.
    This allows them to continue working when the user changes the
    default page format.  Closes #329.

*   Added explicit path to Gitit User's Guide in default front page.

*   Fix Gitit User's Guide link on front page.
    Previously it was broken due to "smart punctuation."

*   Fixed validation messages.  Switched from using lookRead "messages"
    to using looks "message" for messages.  Closes #294.

Version 0.10.0.2 released 02 Nov 2012

*   Raised version bounds for dependencies.

*   Updated post-update script to use new forms of git commands.
    Closes #317.

*   Fixed withTempDir so it returns to old directory.
    Closes #303.  This is a slightly different solution than the one
    proposed by tstgruby, but it has the advantage that only withTempDir
    itself needs to be changed.

*   Added nginx example for proxy setup (README) (Andre Kelpe).

Version 0.10.0.1 released 07 Jun 2012

*   Fixed double-encoding bug for unicode page names
    (Alexander Vershilov).

*   Require happstack-server >= 7.

Version 0.10 released 30 May 2012

*   Changed 'readFileUTF8' so it doesn't encode filename on ghc 7.4.

*   Upgraded for compatibility with blaze-html 0.5.  Closes #299.

*   Improved categories. Files are now read strictly to avoid a 'too
    many open files' error. 'Page' now exports 'readCategories' instead of
    'extractCategories'.

*   Require filestore 0.5.  This brings in (a) correct handling
    of unicode paths when compiled under GHC 7.4, and (b) a 'limit'
    parameter for 'history'. The limit parameter is essential when
    gitit is used with very large repositories; otherwise history
    commands would have to parse the entire log.  Handler functions
    that use 'history' have been updated to use the optional
    'limit' parameter.

*   Atom feeds are now limited to 200 entries, to prevent server
    overload.

*   Indicate size of default logo picture in README. Closes #291.

*   Added a README section on restricting access.  Closes #292.

Version 0.9.0.1 released 15 Feb 2012

*   Fixed bug in fromEntities that caused text to be lost in the page
    source after semicolons.  Thanks to Perry Wagle for reporting the bug.

*   Updated code to run on happstack 7.

*   Removed dependency on happstack-util; depend on base64-bytestring
    instead.

*   Updated gitit.cabal to include footnotes.js (Ben Sinclair).

Version 0.9 released 29 Feb 2012

*   Gitit now uses the latest pandoc (1.9.x) and happstack-server (6.6.x),
    and compiles on ghc 7.4.1.

*   Added Docx, AsciiDoc, and DZSlides as export formats.

*   HTML slide show exports are now "self-contained":  they embed all
    required js, css, and images, so they can be used offline.

*   Allow spaces in usernames (Juraj Hercek).

*   Improve PDF/RTF exports containing images in the wiki.
    Wikidata paths are translated to absolute ones, so pandoc/pdflatex
    can find them (Juraj Hercek).

*   Protect against XSS in slide show exports.  Previous versions
    of gitit sanitized wikipages, but not HTML slide shows.

*   Table of contents is now in a div with ID `TOC`, so it can
    be styled.

*   Removed letter and word spacing from print.css.

*   Added s5 directory to static.  This is needed by pandoc 1.9.

*   Updated Interwiki plugin (gwern).

*   Added `fromEntities` to `Types`, since `decodeCharacterReferences`
    is no longer exported from Pandoc.  Added dependency on tagsoup.

*   Provided `FromReqURI` instance for `[String]`, since
    this is not automatic with recent happstack.

Version 0.8.1 released 02 Sep 2011

*   Support mathjax as a math option.
    Added MathJax as MathMethod, and mathjax as an option in
    the 'math' config field.  Resolves GoogleCode 122.

*   Added xss-sanitize configuaration option.
    Setting it to 'no' turns off sanitization, enabling
    file:// URLs and other things that get filtered out
    by xss-sanitize.

*   Listen interface explanation on help file could be more clear (#266)
    (andyring)

*   Add the new configuration option 'absolute-urls'.
    When turned on, this makes wikilinks absolute w.r.t. the base-url.
    By default, they are relative.  So, for example, in a wiki served
    at the path 'wiki', on a page Sub/Page, the wikilink '[Cactus]()'
    will produce a link to '/wiki/Cactus' if absolute-urls is on,
    and otherwise the relative link 'Cactus'.  Patch due to lemmih.

*   Change default listen address to 0.0.0.0.

*   Serve svg file as image, not source code!

*   Page history:  use 'limit' instead of restricting to past year.
    limit defaults to 100.  If 100 are displayed, you'll get a
    "Show more..." link that will increase the limit.
    Also fixed bug that caused a 404 when no history was returned.

*   Require pandoc >= 1.8.2.

*   Allow build with happstack-server 6.2.

*   Updated for use with xss-sanitize 0.3, which uses Text.
    New dependency on text.

Version 0.8.0.1 released 07 Jun 2011

* Fixed file upload problem with recent versions of directory
  package. (Thanks to Oliver Braun.)

* Relaxed some version upper bounds.

Version 0.8 released 13 May 2011

* Uses happstack 6.

* Added textile and org export formats, textile page format.

* Added support for RPXNow authentication, based on a patch from
  Pasqualino Titto Assini.

* Added `authentication-required` field in config.

    * If set to 'modify', authentication is required to modify the wiki.
    * If set to 'read', atuhentication is required to view the wiki.
    * If set to 'none', authentication is never required, and pages can
      be edited anonymously.

    API changes:

    * currentUser moved to Authentication module
    * requireAuthentication added to Config
    * Added AuthenticationLevel type
    * requireUser renamed authenticate, parameter for AuthenticationLevel
      added; requireUserThat renamed authenticateUserThat

* MathML and jsMath now work in the preview pane (Sean Seefried).

* Use footnotes.js for fancy footnote styling (gwern).

* Added a `--listen` parameter to specify the listen device
  (Timo B. Hübel).

* Removed withInput.

* Replaced fileContents with filePath in Params.

* Fixed bug in uploadForm.js which caused a prefix to be added in the
  default wikiname.


Version 0.7.3.12 released 01 Feb 2011

* Use pandoc 1.8.

* New export formats: textile, org.

* New page form: textile.

Version 0.7.3.11 released 28 Jan 2011

* Allow time 1.2.

Version 0.7.3.10 released 26 Jan 2011

* Updated for filestore-0.4.0.2.  Gitit should now compile with ghc 7.
  Note:  It may be necessary to supply the --disable-library-for-ghci
  flag to 'cabal install highlighting-kate'.

Version 0.7.3.9 released 25 Jan 2011

* Removed dependency on cautious-file.
  It no longer seems to be actively maintained, and the current
  configuration does not compile on windows.

* Removed dependency on datetime package.
  It is no longer maintained.
  Everything can be done just as well with the time package.

* Depend on filestore >= 0.4 (without datetime dependency).

* Bump version bounds on hslogger, network and HTTP.

* Support for GHC 7.0 in Plugins (thanks to Max Bollingbroke).

* Use xss-sanitize for sanitizing HTML.
  Previously pandoc's sanitization was used, but this will be
  removed in the next pandoc release. xss-sanitize is a more complete
  solution, and also prevents people from messing up layout by inserting
  unbalanced </div>.

* Updated Feed module to make it decouplable from gitit.

* jQuery.load wasn't working on Safari. Use jQuery.post instead.
  Also, the convert function was not always in scope. (It is only in
  scope when MathML is enabled?) We check if it is defined before
  calling it.  (Thanks to Sean Seefried.)

* Export Page module.

* Templates are in data directory

* Fixed bug in Subst plugin (Lars Petersen).
  Subst plugin could not deal with non-existing pages, resulting
  in an server error when trying to substitute with an absent file.
  This patch now creates a link to the page in order to create it.

* Added alt attribute to logo.

Version 0.7.3.8 released 24 July 2010

* Fixed MathML in Slidy and S5 exports.

* Use languagesByFilename instead of languagesByExtension in isSource.

Version 0.7.3.7 released 24 July 2010

* Depend on pandoc >= 1.6, highlighting-kate >= 0.2.7.1

* Added epub and slidy export formats.

* Require happstack >= 0.5.

* Added google math option (uses google charts api).
  Slightly modified from a patch by lpeterse.

* Made WebArchiver plugin more parallel (gwern).

* Fixed Dot plugin to work with GHC 6.12.
  We were having string encoding issues reading the output
  of dot with readProcess. Solution is to pass dot an output
  filename so we don't have to read its output.

Version 0.7.3.6 released 05 May 2010

* Fixed ODT/PDF export for files in subdirectories.  Resolves Issue #81.

* Fix image URLs before calling the ODT or PDF processors

* Added plain text export format.

* Raised upper bound for datetime, parsec, and happstack dependencies.

* Fix wikilinks to they don't get a leading slash.
  This reverts a bug introduced by 2128afb070b7, which added leading
  slashes to wikilinks, breaking them for people using gitit as a
  library on a path other than /.

Version 0.7.3.5 released 21 Mar 2010

* Returned to using pandoc's MathML writer option.
  This is fixed in pandoc 1.5.0.1. Depend on pandoc >= 1.5.0.1.

Version 0.7.3.4 released 21 Mar 2010

* Use custom readFileUTF8 (exported in Network.Gitit.Util) instead of
  broken System.IO.UTF8. This way we have a uniform solution for GHC
  6.10 and 6.12, and don't have to use CPP tricks. This change fixes
  categories on GHC 6.12. Resolves Issue #98.

Version 0.7.3.3 released 21 Mar 2010

* Reverted to handling math in MathML mode in the old way, using
  a transform, rather than relying on pandoc's MathML writer option.
  The latter was causing amazing CPU and memory usage, for reasons
  I don't yet understand.  This should fix the problem for now.

* Fixed caching for unicode page names.

* Added max-page-size config option. Thanks to Jinjing Wang for the patch.

* Prevented _expire/ from failing if the page is not cached.

* Fixed URL encoding for pages. (Note: Don't use + for spaces;
  that breaks the Ctrl-R cache expiration.)

Version 0.7.3.2 released 20 Mar 2010

* Fixed editing of pages when max-upload-size=0.
  max-upload-size should not double as max-page-size.
  Resolves Issue #96.

Version 0.7.3.1 released 20 Mar 2010

* Changed "In" to "in" in MathMLinJS.js link.

Version 0.7.3 released 20 Mar 2010

* Added PDF export option and pdf-export config field.
  (Based on a patch by gwern.)

* Added markdown export.

* Use pandoc's new MathML math mode for more efficient
  MathML.

* Improved multi-wiki example code in haddocks.

* Added session-timeout config setting.

* Config module:  Added readSize (recognizing K,M,G suffix).
  Previously readNumber always recognized K,M,G suffixes,
  but these only make sense in some contexts (not e.g. for
  times).

* Added Subst plugin (thanks to gwern).

* Added notes on PDF caching and idle.

* Fixed table of contents in wiki pages (resolving Issue #91).

* Added pandoc-user-data config option, allowing the user
  to specify a directory with e.g. templates that override
  the defaults used for exported pages.

* Fix filesToClean GHC panic when loading plugins on GHC HEAD

* Fixed problem with doubled // in updir links.
  Resolves Issue #88.

* Updated interwiki plugin.

* Fixed caching for feeds. Thanks to brian.sniffen for pointing
  out the need to normalize the time diff. Resolves Issue #87.

* Improved Feed module (gwern).

* Use line anchors from highlighting-source, so that you can link
  directly to a particular line in a source file.

* Disable upload functionality if maxUploadSize is 0.

* Exported queryGititState, updateGititState, Network.Gitit.Layout.
  Exported filledPageTemplate. (Thanks to tphyahoo.)
  Split off and expose createDefaultPages.
  Exposed compilePageTemplate.

* Use charset=utf-8 on output from Layout.

* Use isUnescapedInURI with escapeURIString rather than isAllowedInURI.
  The latter does not escape % signs.

Version 0.7.2 released 02 Jan 2010

* Now compiles with GHC 6.12.

Version 0.7.1 released 02 Jan 2010

* Updated exports to work with pandoc 1.4.

* Began updating to work with GHC 6.12. (Still untested; there may
  be further issues involving filestore.)

Version 0.7 released 20 Dec 2009

* Updated cabal file to allow happstack 0.4.

* Added support for the new mercurial filestore backend.
  (Depending on filestore >= 0.3.4.)

* Depend on xml >= 1.3.5.  This fixes a bug in the display of
  mathml.  Previously the self-closed tags in matrices with empty
  cells confused browsers and caused them to construct the
  DOM incorrectly. The problem is fixed by using xml's new
  ppcElement function to render the MathML without self-closed tags.

* Depend on pandoc >= 1.3.

* Properly handle UTF-8 in config files.

* Moved option parsing code from Config module to main program.
  The Config module now exports getConfigFromFile instead of
  getConfigFromOpts. This should be more useful for those using gitit as
  a library.

* Use wikiTitle config field in default HTML title.

* Improved search results:
  + Highlight search terms in search results.
    Partially resolves Issue #76.
  + Made search results message uniform when no results.
  + Search: don't match page name against empty patterns.
  + Allow search matches on subdirectory part of page name.
  + Search:  catch error status from filestore search.
    Filestore <= 0.3.3 does not properly handle the error status
    returned by later versions of 'git grep' when no match is found.
    The problem has been fixed in darcs filestore.

* CSS tweaks:
  + Removed base-min.css, folded necessary styles into screen.css.
  + Removed 'text-align: left' for th from CSS reset.

* Feed improvements:
  + Modified feed handling so that feeds validate.
  + Perform proper escaping in Feed.hs (thanks to gwern).
  + Don't reveal author email in feeds.
  + Sitewide feed is /_feed/ (with trailing slash).
  + Add "http://" to base-url config option if needed.

* Use + for spaces in URLs linking to wiki pages and folders.

* Updated plugins:
  + Updated Interwiki plugin (gwern).
  + Modified WebArchiver plugin to make Alexa requests (gwern).

Version 0.6.6 released 06 Nov 2009

* Require filestore >= 0.3.3, which closes a security
  vulnerability.

* Don't allow web file uploads to the static or templates directory,
  even if these are subdirectories of the repository directory.
  We don't want users uploading new CSS, javascript, or templates
  that might break the site.

* Renamed gitit-dog.png -> logo.png in data/static/img.
  This way the logo will show up even without a local img directory.
  Thanks to Thomas Hartmann for the patch.

* Return 404 when page not found.  Thanks to Richard Fergie.

* Improved layout of Export button.

* Added links for atom feeds to sitenav.st and pagetools.st, to
  make the feeds more discoverable.

* Minor code safety improvements.

* Check for commit messages consisting of whitespace.
  Commit messages consisting only of whitespace characters are
  rejected by Git as empty. Gitit should behave similarly.

* Allow gitit to start up if custom template directory not found.
  Thanks to Thomas Hartmann.

* Fixed incorrect usage of nullGroup (a debugging function).  Thanks
  to Thomas Hartmann.

Version 0.6.5 released 06 Oct 2009

* Added metadata to Page and Context, provided askMeta for plugins.
  This patch gives plugins access to all of the key/value pairs
  in the page metadata block.  Thanks to Dan Cook.

* Added PigLatin plugin to demonstrate use of askMeta.

* Display informative message on authentication failure.

* Fixed library stanza in cabal file so plugins are properly enabled.

Version 0.6.4 released 28 Sep 2009

* Fixed preview javascript so that tex math works properly in
  preview.

Version 0.6.3 released 27 Sep 2009

* Fixed MathML conversion so it doesn't happen when exporting to
  non-HTML output formats.

* Fixed shadowing on page templates: previously page.st was always
  taken from the defaults, even if a modified version existed
  in templates/.

* Modified YUI CSS reset so that ordered list enumerators can be
  styled properly.

* Modified showPage to work with both POST and GET requests.

Version 0.6.2 released 25 Aug 2009

* Use "reference obfuscation" for emails, rather than javascript
  obfuscation, which seems to interfere with preview.  Resolves
  Issue #59.

Version 0.6.1 released 25 Aug 2009

Instructions for upgrading from 0.5.3:

- If you were using a Haskell configuration file, you will
  need to create a new configuration file. 'gitit --print-default-config'
  will print a self-documenting default configuration file in the new
  format, which you can modify.

- If your wiki contains discuss pages of the form 'foo:discuss.page',
  rename them to '@foo.page'.

- Delete template.html and the static directory so that these will
  be replaced by the newest versions when you run gitit. If you have
  customized these, you should back them up first, then merge your
  changes into the new versions after they are created. (Note that
  template.html will be replaced by a templates/ directory.)

Summary of main changes:

* Added support for plugins -- dynamically loaded Haskell programs that
  transform pages. See the haddock documentation for Gitit.Interface for
  plugin documentation. The plugins directory contains several sample
  plugins.

* Gitit's configuration file is now a text file with key-value pairs,
  rather than a Haskell file.  The default configuration file
  (which can be printed using `gitit --print-default-config`
  contains comments that document all of the options.

* Pages may now be written in (limited dialects of) LaTeX or HTML,
  as well as markdown and reStructuredText.  The default format
  is determined by a configuration option, but can be overridden
  on a per-page basis using metadata (see below).  The default
  Front Page and Help page are created in the default format specified
  by the configuration file. In addition, syntax help is now displayed
  to the left of the editing box when a page is being edited.

* Pages may be written in literate Haskell, using either bird
  style with markdown or reStructuredText, or LaTeX style with
  LaTeX.  Literate Haskell can be made the default or specified on
  a per-page basis.

* Gitit now exports a library, Network.Gitit, that makes it easy for
  any happstack application to embed a gitit wiki.

* Added optional atom feeds, for whole site (at /_feed)
  and for individual pages (at /_feed/path/to/page).
  Feeds are cached with a configurable expiration time.

* Completely new caching system.  Caching is turned off by default and
  can be enabled by a configuration option.  Complete pages are cached
  on disk and expired when pages are revised through the web interface.
  When pages are modified directly through a VCS, the cache must be
  refreshed manually, either by pressing Ctrl-R while viewing a page,
  or by sending an HTTP request to /_expire/path/to/page, or by using
  the included program expireGititPath. The new system is much faster
  than the old in-memory cache, because it avoids the considerable
  overhead of filestore calls to get the current revision id.

* To make whole-page caching possible, the user login/out box has been
  made into an ajax request to /_user.  jQuery is now loaded on every
  page.

* Math is converted to MathML by default (using the texmath library),
  and a javascript is linked in that renders it correctly in IE+mathplayer,
  Firefox, and Opera.  The 'math' configuration setting can alternatively
  be set to 'jsMath' (to use jsMath javascript, which is more portable
  but ugly and slower) or 'raw' (plain LaTeX code).

* Routing changes for better handling of web spiders.  Instead of
  "/foo?history" we now have "/_history/foo"; instead of "/foo?edit"
  we haev "/_edit/foo"; etc.  This makes it possible to exclude web
  spiders from non-cached pages by excluding URLs that start with
  '/_'.  A default robots.txt file is now provided.  Users need not
  do anything special for this to be enabled.

* The authentication system has been revised and made much more
  flexible. In the configuration file, you can specify either
  'form', 'http', or 'generic' as authentication-method. Form
  authentication is the old form-based gitit authentication system. HTTP
  authentication presupposes that the wiki pages are locked down under
  HTTP authentication; the gitit user will be set to the username used
  for HTTP authentication. Generic authentication takes the username
  from the REMOTE_USER request header. When gitit is being used as a
  library, one can specify a custom withUser filter (which determines
  the logged in user and sets REMOTE_USER accordingly) and a custom
  authHandler (including handlers for /_login, /_logout, and whatever
  else is needed).

* Security fix: Gitit did not verify that a change password request
  is genuine when it receives the final POST. It has been changed to
  re-verify the reset code, otherwise an attacker could simply steal
  anyone's account by spoofing a POST request. (Thanks to Robin Green.)

* template.html has now been replaced by a directory, templates/, with
  separate templates for each component of a page.

* Added /_reloadTemplates action that recompiles the templates. (By
  default the templates are compiled only on startup.)

* Gitit's form-based authentication now includes a "password reset"
  email.  Slightly modified from a patch from Henry Laxen.

* The naming scheme for discussion pages has changed: the discussion
  page for foo is now @foo, not foo:discuss. Reason: Windows, and
  thus darcs, does not like colons in filenames.

* Improved logging, with configurable verbosity.

* Major code reorganization and cleanup.  Gitit has been moved under
  the Network namespace. The old WebT handlers are replaced by new ones
  in ServerPartT. 'handle' has been removed; instead, we use happstack's
  routing combinators. Configuration and filestores are now passed
  around in a reader monad, in WikiState. (This also allows different
  wikis to have different configurations.) Most handlers have been
  simplified so that they no longer require Page and Params arguments.
  A new function, 'withInput', is used to avoid the need to pass Params
  between handlers.

* The static handler now "falls back" to the cabal data directory if the
  requested file is not in "static" (or staticDir).  So the user need
  no longer have a copy of the standard gitit CSS, javascript, and
  image files in "static" (unless these are to be overridden). This
  should make updates easier.  By default only 'custom.css' and
  'logo.png' are put in the user's static directory.

* Similarly, the templates in "templates" "fall back" to defaults in
  the cabal data directory.  By default only 'footer.st' is put in
  the user's static directory.

* Gitit State now includes a renderPage function. This is more flexible
  than storing a page template, since the user may want to use a custom
  page rendering function, even one not based on string templates.

* Added Network.Gitit.ContentTransformer module (thanks to Anton van
  Straaten). The ContentTransformer module replaces Gitit.Convert. It
  defines a number of single-purpose combinators that can be combined to
  yield various kinds of content conversions. These are used to define
  showPage, preview, showHighlightedSource, and other handlers that used
  to be defined in Gitit.hs.

* Verify in delete POST requests that filetodelete parameter matches
  page.

* Fixed revert when called from diff pages. Revert now reverts to the
  older of the two revisions being compared.

* Revamped auto-merging: user must now verify an edited page after
  a merge, even if there were no conflicts.

* Fixed Content-Disposition header on export so that filenames have
  proper extensions.

* Updated for happstack-server-0.3.3.  Since this version of happstack
  supports UTF-8, gitit's old manual decoding and encoding were removed.

* Use fileServeStrict instead of fileServe.  Resolves Issue #57.

* 'limit' is no longer used in search.  The way it worked before was
  confusing, since it limited total matches (usually to just a few files)
  rather than limiting the number of matches in each file.

* rdgreen's cautious-file library is now used to write the gitit-users
  file. This makes it less likely that the file will be corrupted on
  a power outage or hardware failure.

* Redirects set properly after account creation.  If users go from
  the Login form to the Register form, they are no longer redirected
  back to the Login form after creating an account.

* indexPage now uses filestore's new 'directory' function. It shows one
  directory at a time. Subdirectories link to further index pages. This
  improves on the old javascript folding interface, which did not preserve
  state.  (Thanks to Thomas Hartman for suggestions.)

* URLs of the form /a/b/ are now equivalent to /_index/a/b.

* Improvements and bug fixes to deleting. Deleting a non-page now works.
  You get a nice informative message if you try to delete a nonexistent
  page or file.

* Page names containing "..", "?", or "*", and '_' at beginning are
  disallowed. Page names may now contain periods.

* The "Permanent link" link has been removed. It relied on the sha1
  parameter always being set, but we've changed that for performance
  reasons.

* Gitit can now be proxied to a subdirectory path. Thanks to Henry Laxen
  for the idea and patches. See README for instructions.

* Performance improvements (mostly due to Gwern Branwen):  Pages can be
  compressed (configurable); unneeded filestore calls removed; cache-control:
  max-age used.

* Moved sidebar to end of HTML to make things easier for screen readers.

* Moved search box and go box to templates.

* Yahoo YUI CSS framework is now used for better consistency across browsers.
  CSS cleaned up.  Icons for page types removed.

* Fixed handling of 'forUser' parameter in 'recent activity'.

* Made default maxUploadSize 10 Mb.

* Renamed AppState -> GititState.

Version 0.5.3 released 1 Feb 2009

* Fixed bug which caused jsMath not to load.

Version 0.5.2 released 1 Feb 2009

* Fixed cookie problem caused by empty value fields.

Version 0.5.1 released 1 Feb 2009

* Major code reorganization, making gitit more modular.

* Gitit can now optionally be built using Happstack instead of HAppS
  (just use -fhappstack when cabal installing).

* Fixed bug with directories that had the same names as pages.

* Added code from HAppS-Extra to fix cookie parsing problems.

* New command-line options for --port, --debug.

* New debug feature prints the date, the raw request, and
  the processed request data to standard output on each request.

* Files with ".page" extension can no longer be uploaded.

* Apostrophes and quotation marks now allowed in page names.

